package dev.shadowsoffire.apotheosis.ench.table;

import java.util.function.Function;
import java.util.Comparator;
import java.util.Collection;
import it.unimi.dsi.fastutil.floats.Float2FloatOpenHashMap;
import it.unimi.dsi.fastutil.floats.Float2FloatMap;
import java.util.HashSet;
import net.minecraft.network.FriendlyByteBuf;
import java.util.Collections;
import net.minecraft.util.Mth;
import java.util.function.Predicate;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.inventory.MenuType;
import java.util.Set;
import net.minecraft.world.level.block.state.BlockState;
import java.util.function.Consumer;
import java.util.Objects;
import net.minecraft.world.level.LevelReader;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;
import net.minecraft.tags.BlockTags;
import java.util.Iterator;
import net.minecraft.core.Vec3i;
import net.minecraft.world.level.block.EnchantmentTableBlock;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Optional;
import dev.shadowsoffire.placebo.network.PacketDistro;
import dev.shadowsoffire.apotheosis.Apotheosis;
import java.util.ArrayList;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraftforge.event.ForgeEventFactory;
import java.util.List;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.advancements.CriteriaTriggers;
import dev.shadowsoffire.apotheosis.advancements.EnchantedTrigger;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.stats.Stats;
import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import dev.shadowsoffire.placebo.util.EnchantmentUtils;
import dev.shadowsoffire.apotheosis.util.ApothMiscUtil;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.SlotItemHandler;
import net.minecraftforge.common.Tags;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.Container;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.EnchantmentMenu;

public class ApothEnchantmentMenu extends EnchantmentMenu
{
    protected TableStats stats;
    protected final Player player;
    
    public ApothEnchantmentMenu(final int id, final Inventory inv) {
        super(id, inv, ContainerLevelAccess.f_39287_);
        this.stats = TableStats.INVALID;
        this.player = inv.f_35978_;
        this.f_38839_.clear();
        this.addSecretSlot(new Slot(this.f_39449_, 0, 15, 47) {
            public boolean m_5857_(final ItemStack stack) {
                return true;
            }
            
            public int m_6641_() {
                return 1;
            }
        });
        this.addSecretSlot(new Slot(this.f_39449_, 1, 35, 47) {
            public boolean m_5857_(final ItemStack stack) {
                return stack.m_204117_(Tags.Items.ENCHANTING_FUELS);
            }
        });
        this.initCommon(inv);
    }
    
    public ApothEnchantmentMenu(final int id, final Inventory inv, final ContainerLevelAccess wPos, final ApothEnchantTile te) {
        super(id, inv, wPos);
        this.stats = TableStats.INVALID;
        this.player = inv.f_35978_;
        this.f_38839_.clear();
        this.addSecretSlot(new Slot(this.f_39449_, 0, 15, 47) {
            public boolean m_5857_(final ItemStack stack) {
                return true;
            }
            
            public int m_6641_() {
                return 1;
            }
        });
        this.addSecretSlot((Slot)new SlotItemHandler(te.inv, 0, 35, 47) {
            public boolean m_5857_(final ItemStack stack) {
                return stack.m_204117_(Tags.Items.ENCHANTING_FUELS);
            }
        });
        this.initCommon(inv);
    }
    
    protected Slot addSecretSlot(final Slot pSlot) {
        pSlot.f_40219_ = this.f_38839_.size();
        this.f_38839_.add((Object)pSlot);
        return pSlot;
    }
    
    private void initCommon(final Inventory inv) {
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.addSecretSlot(new Slot((Container)inv, j + i * 9 + 9, 8 + j * 18, 84 + i * 18 + 31));
            }
        }
        for (int k = 0; k < 9; ++k) {
            this.addSecretSlot(new Slot((Container)inv, k, 8 + k * 18, 173));
        }
    }
    
    public boolean m_6366_(final Player player, final int id) {
        final int slot = id;
        final int level = this.f_39446_[slot];
        final ItemStack toEnchant = this.f_39449_.m_8020_(0);
        final ItemStack lapis = this.m_38853_(1).m_7993_();
        final int cost = slot + 1;
        if ((lapis.m_41619_() || lapis.m_41613_() < cost) && !player.m_150110_().f_35937_) {
            return false;
        }
        if (this.f_39446_[slot] <= 0 || toEnchant.m_41619_() || ((player.f_36078_ < cost || player.f_36078_ < this.f_39446_[slot]) && !player.m_150110_().f_35937_)) {
            return false;
        }
        this.f_39450_.m_39292_((world, pos) -> {
            final ItemStack enchanted = toEnchant;
            final float eterna = this.stats.eterna;
            final float quanta = this.stats.quanta;
            final float arcana = this.stats.arcana;
            final float rectification = this.stats.rectification;
            final List<EnchantmentInstance> list = this.m_39471_(toEnchant, slot, this.f_39446_[slot]);
            if (!list.isEmpty()) {
                EnchantmentUtils.chargeExperience(player, ApothMiscUtil.getExpCostForSlot(level, slot));
                player.m_7408_(toEnchant, 0);
                if (((EnchantmentInstance)list.get(0)).f_44947_ == Ench.Enchantments.INFUSION.get()) {
                    final EnchantingRecipe match = EnchantingRecipe.findMatch(world, toEnchant, eterna, quanta, arcana);
                    if (match != null) {
                        this.f_39449_.m_6836_(0, match.assemble(toEnchant, eterna, quanta, arcana));
                    }
                    else {
                        return;
                    }
                }
                else {
                    this.f_39449_.m_6836_(0, ((IEnchantableItem)toEnchant.m_41720_()).onEnchantment(toEnchant, list));
                }
                if (!player.m_150110_().f_35937_) {
                    lapis.m_41774_(cost);
                    if (lapis.m_41619_()) {
                        this.f_39449_.m_6836_(1, ItemStack.f_41583_);
                    }
                }
                player.m_36220_(Stats.f_12964_);
                if (player instanceof final ServerPlayer serverPlayer) {
                    ((EnchantedTrigger)CriteriaTriggers.f_10575_).trigger(serverPlayer, enchanted, level, eterna, quanta, arcana, rectification);
                }
                this.f_39449_.m_6596_();
                this.f_39452_.m_6422_(player.m_36322_());
                this.m_6199_(this.f_39449_);
                world.m_5594_((Player)null, pos, SoundEvents.f_11887_, SoundSource.BLOCKS, 1.0f, world.f_46441_.m_188501_() * 0.1f + 0.9f);
            }
            return;
        });
        return true;
    }
    
    public void m_6199_(final Container inventoryIn) {
        this.f_39450_.m_6721_((world, pos) -> {
            if (inventoryIn == this.f_39449_) {
                final ItemStack toEnchant = inventoryIn.m_8020_(0);
                this.gatherStats();
                final EnchantingRecipe match = EnchantingRecipe.findItemMatch(world, toEnchant);
                if (toEnchant.m_41613_() == 1 && (match != null || (toEnchant.m_41720_().m_8120_(toEnchant) && isEnchantableEnough(toEnchant)))) {
                    float eterna = this.stats.eterna();
                    if (eterna < 1.5) {
                        eterna = 1.5f;
                    }
                    this.f_39451_.m_188584_((long)this.f_39452_.m_6501_());
                    for (int slot = 0; slot < 3; ++slot) {
                        this.f_39446_[slot] = RealEnchantmentHelper.getEnchantmentCost(this.f_39451_, slot, eterna, toEnchant);
                        this.f_39447_[slot] = -1;
                        this.f_39448_[slot] = -1;
                        if (this.f_39446_[slot] < slot + 1) {
                            final int[] f_39446_ = this.f_39446_;
                            final int n;
                            ++f_39446_[n];
                        }
                        this.f_39446_[slot] = ForgeEventFactory.onEnchantmentLevelSet(world, pos, slot, Math.round(eterna), toEnchant, this.f_39446_[slot]);
                    }
                    for (int slot2 = 0; slot2 < 3; ++slot2) {
                        if (this.f_39446_[slot2] > 0) {
                            final List<EnchantmentInstance> list = this.m_39471_(toEnchant, slot2, this.f_39446_[slot2]);
                            if (list != null && !list.isEmpty()) {
                                final EnchantmentInstance enchantmentdata = (EnchantmentInstance)list.remove(this.f_39451_.m_188503_(list.size()));
                                this.f_39447_[slot2] = BuiltInRegistries.f_256876_.m_7447_((Object)enchantmentdata.f_44947_);
                                this.f_39448_[slot2] = enchantmentdata.f_44948_;
                                int clues = this.stats.clues();
                                final ArrayList<EnchantmentInstance> clueList = new ArrayList<EnchantmentInstance>();
                                clues--;
                                final Object o3;
                                if (o3 > 0) {
                                    clueList.add(enchantmentdata);
                                }
                                while (true) {
                                    clues--;
                                    final int n2;
                                    if (n2 > 0 && !list.isEmpty()) {
                                        clueList.add(list.remove(this.f_39451_.m_188503_(list.size())));
                                    }
                                    else {
                                        break;
                                    }
                                }
                                PacketDistro.sendTo(Apotheosis.CHANNEL, (Object)new ClueMessage(slot2, clueList, list.isEmpty()), this.player);
                            }
                        }
                    }
                    this.m_38946_();
                }
                else {
                    for (int i = 0; i < 3; ++i) {
                        this.f_39446_[i] = 0;
                        this.f_39447_[i] = -1;
                        this.f_39448_[i] = -1;
                    }
                    this.stats = TableStats.INVALID;
                    PacketDistro.sendTo(Apotheosis.CHANNEL, (Object)new StatsMessage(this.stats), this.player);
                }
            }
            return this;
        });
    }
    
    private List<EnchantmentInstance> m_39471_(final ItemStack stack, final int enchantSlot, final int level) {
        this.f_39451_.m_188584_((long)(this.f_39452_.m_6501_() + enchantSlot));
        final List<EnchantmentInstance> list = RealEnchantmentHelper.selectEnchantment(this.f_39451_, stack, level, this.stats.quanta(), this.stats.arcana(), this.stats.rectification(), this.stats.treasure(), this.stats.blacklist());
        final EnchantingRecipe match = this.f_39450_.m_6721_((world, pos) -> Optional.ofNullable(EnchantingRecipe.findMatch(world, stack, this.stats.eterna(), this.stats.quanta(), this.stats.arcana()))).get().orElse(null);
        if (enchantSlot == 2 && match != null) {
            list.clear();
            list.add(new EnchantmentInstance((Enchantment)Ench.Enchantments.INFUSION.get(), 1));
        }
        return list;
    }
    
    public void gatherStats() {
        this.f_39450_.m_6721_((world, pos) -> {
            this.stats = gatherStats(world, pos, this.m_38853_(0).m_7993_().getEnchantmentValue());
            PacketDistro.sendTo(Apotheosis.CHANNEL, (Object)new StatsMessage(this.stats), this.player);
            return this;
        }).orElse(this);
    }
    
    public static TableStats gatherStats(final Level level, final BlockPos pos, final int itemEnch) {
        final TableStats.Builder builder = new TableStats.Builder(itemEnch);
        for (final BlockPos offset : EnchantmentTableBlock.f_207902_) {
            if (canReadStatsFrom(level, pos, offset)) {
                gatherStats(builder, level, pos.m_121955_((Vec3i)offset));
            }
        }
        return builder.build();
    }
    
    public static boolean canReadStatsFrom(final Level level, final BlockPos tablePos, final BlockPos offset) {
        return level.m_8055_(tablePos.m_7918_(offset.m_123341_() / 2, offset.m_123342_(), offset.m_123343_() / 2)).m_204336_(BlockTags.f_278486_);
    }
    
    public static void gatherStats(final TableStats.Builder builder, final Level world, final BlockPos pos) {
        final BlockState state = world.m_8055_(pos);
        if (state.m_60795_()) {
            return;
        }
        final float eterna = EnchantingStatRegistry.getEterna(state, world, pos);
        final float max = EnchantingStatRegistry.getMaxEterna(state, world, pos);
        builder.addEterna(eterna, max);
        builder.addQuanta(EnchantingStatRegistry.getQuanta(state, world, pos));
        builder.addArcana(EnchantingStatRegistry.getArcana(state, world, pos));
        builder.addRectification(EnchantingStatRegistry.getQuantaRectification(state, world, pos));
        builder.addClues(EnchantingStatRegistry.getBonusClues(state, world, pos));
        final Set blacklistedEnchantments = ((IEnchantingBlock)state.m_60734_()).getBlacklistedEnchantments(state, (LevelReader)world, pos);
        Objects.requireNonNull(builder);
        blacklistedEnchantments.forEach(builder::blacklistEnchant);
        if (((IEnchantingBlock)state.m_60734_()).allowsTreasure(state, (LevelReader)world, pos)) {
            builder.setAllowsTreasure(true);
        }
    }
    
    public MenuType<?> m_6772_() {
        return (MenuType<?>)Apoth.Menus.ENCHANTING_TABLE.get();
    }
    
    public static boolean isEnchantableEnough(final ItemStack stack) {
        return !stack.m_41793_() || EnchantmentHelper.m_44831_(stack).keySet().stream().allMatch(Enchantment::m_6589_);
    }
    
    public enum Arcana
    {
        EMPTY(0.0f, new int[] { 10, 5, 2, 1 }), 
        LITTLE(10.0f, new int[] { 8, 5, 3, 1 }), 
        FEW(20.0f, new int[] { 7, 5, 4, 2 }), 
        SOME(30.0f, new int[] { 5, 5, 4, 2 }), 
        LESS(40.0f, new int[] { 5, 5, 4, 3 }), 
        MEDIUM(50.0f, new int[] { 5, 5, 5, 5 }), 
        MORE(60.0f, new int[] { 3, 4, 5, 5 }), 
        VALUE(70.0f, new int[] { 2, 4, 5, 5 }), 
        EXTRA(80.0f, new int[] { 2, 4, 5, 7 }), 
        ALMOST(90.0f, new int[] { 1, 3, 5, 8 }), 
        MAX(99.0f, new int[] { 1, 2, 5, 10 });
        
        final float threshold;
        final int[] rarities;
        static Arcana[] VALUES;
        
        private Arcana(final float threshold, final int[] rarities) {
            this.threshold = threshold;
            this.rarities = rarities;
        }
        
        public int[] getRarities() {
            return this.rarities;
        }
        
        public static Arcana getForThreshold(final float threshold) {
            for (int i = Arcana.VALUES.length - 1; i >= 0; --i) {
                if (threshold >= Arcana.VALUES[i].threshold) {
                    return Arcana.VALUES[i];
                }
            }
            return Arcana.EMPTY;
        }
        
        static {
            Arcana.VALUES = values();
        }
    }
    
    record TableStats(float eterna, float quanta, float arcana, float rectification, int clues, Set<Enchantment> blacklist, boolean treasure) {
        public static TableStats INVALID;
        
        public TableStats(final float eterna, final float quanta, final float arcana, final float rectification, final int clues, final Set<Enchantment> blacklist, final boolean treasure) {
            this.eterna = Mth.m_14036_(eterna, 0.0f, EnchantingStatRegistry.getAbsoluteMaxEterna());
            this.quanta = Mth.m_14036_(quanta, 0.0f, 100.0f);
            this.arcana = Mth.m_14036_(arcana, 0.0f, 100.0f);
            this.rectification = Mth.m_14036_(rectification, 0.0f, 100.0f);
            this.clues = Math.max(clues, 0);
            this.blacklist = Collections.unmodifiableSet((Set<? extends Enchantment>)blacklist);
            this.treasure = treasure;
        }
        
        public TableStats(final float[] data, final Set<Enchantment> blacklist, final boolean treasure) {
            this(data[0], data[1], data[2], data[3], (int)data[4], blacklist, treasure);
        }
        
        public void write(final FriendlyByteBuf buf) {
            buf.writeFloat(this.eterna);
            buf.writeFloat(this.quanta);
            buf.writeFloat(this.arcana);
            buf.writeFloat(this.rectification);
            buf.writeByte(this.clues);
            buf.writeShort(this.blacklist.size());
            for (final Enchantment e : this.blacklist) {
                buf.m_130130_(BuiltInRegistries.f_256876_.m_7447_((Object)e));
            }
            buf.writeBoolean(this.treasure);
        }
        
        public static TableStats read(final FriendlyByteBuf buf) {
            final float[] data = { buf.readFloat(), buf.readFloat(), buf.readFloat(), buf.readFloat(), buf.readByte() };
            final int size = buf.readShort();
            final Set<Enchantment> blacklist = new HashSet<Enchantment>(size);
            for (int i = 0; i < size; ++i) {
                blacklist.add((Enchantment)BuiltInRegistries.f_256876_.m_7942_(buf.m_130242_()));
            }
            final boolean treasure = buf.readBoolean();
            return new TableStats(data, blacklist, treasure);
        }
        
        static {
            TableStats.INVALID = new TableStats(0.0f, 0.0f, 0.0f, 0.0f, 0, Collections.emptySet(), false);
        }
        
        public static class Builder
        {
            private final Float2FloatMap eternaMap;
            private final Set<Enchantment> blacklist;
            private boolean allowsTreasure;
            private final float[] stats;
            
            public Builder(final int itemEnch) {
                this.eternaMap = (Float2FloatMap)new Float2FloatOpenHashMap();
                this.blacklist = new HashSet<Enchantment>();
                this.allowsTreasure = false;
                this.stats = new float[5];
                this.addQuanta(15.0f);
                this.addArcana(itemEnch / 2.0f);
                this.addClues(1);
            }
            
            public void addEterna(final float eterna, final float max) {
                this.eternaMap.put(max, this.eternaMap.getOrDefault(max, 0.0f) + eterna);
            }
            
            public void addQuanta(final float quanta) {
                final float[] stats = this.stats;
                final int n = 1;
                stats[n] += quanta;
            }
            
            public void addArcana(final float arcana) {
                final float[] stats = this.stats;
                final int n = 2;
                stats[n] += arcana;
            }
            
            public void addRectification(final float rectification) {
                final float[] stats = this.stats;
                final int n = 3;
                stats[n] += rectification;
            }
            
            public void addClues(final int clues) {
                final float[] stats = this.stats;
                final int n = 4;
                stats[n] += clues;
            }
            
            public void blacklistEnchant(final Enchantment ench) {
                this.blacklist.add(ench);
            }
            
            public void setAllowsTreasure(final boolean allowsTreasure) {
                this.allowsTreasure = allowsTreasure;
            }
            
            public TableStats build() {
                final List<Float2FloatMap.Entry> entries = new ArrayList<Float2FloatMap.Entry>((Collection<? extends Float2FloatMap.Entry>)this.eternaMap.float2FloatEntrySet());
                Collections.sort(entries, Comparator.comparing((Function<? super Float2FloatMap.Entry, ? extends Comparable>)Float2FloatMap.Entry::getFloatKey));
                for (final Float2FloatMap.Entry e : entries) {
                    if (e.getFloatKey() > 0.0f) {
                        this.stats[0] = Math.min(e.getFloatKey(), this.stats[0] + e.getFloatValue());
                    }
                    else {
                        final float[] stats = this.stats;
                        final int n = 0;
                        stats[n] += e.getFloatValue();
                    }
                }
                return new TableStats(this.stats, this.blacklist, this.allowsTreasure);
            }
        }
    }
}
